% TMT method for generalized coordinates
% And changed the friction force calculation - ellipsoid approximation

syms x_r y_r theta_r phi d  real
syms d_x_r d_y_r d_theta_r d_phi d_d real
syms dd_x_r dd_y_r dd_theta_r dd_phi dd_d real
% syms v_r acc_r real
syms x_o y_o theta_o real
syms r_r W_o real
syms m_r m_o I_r I_o real

% d_x_r = cos(theta_r) * v_r;
% d_y_r = sin(theta_r) * v_r;
% 
% dd_x_r = -sin(theta_r) * d_theta_r * v_r + cos(theta_r) * acc_r;
% dd_y_r = cos(theta_r) * d_theta_r * v_r + sin(theta_r) * acc_r;
% dd_x_r = cos(theta_r) * acc_r;
% dd_y_r = sin(theta_r) * acc_r;

theta_o = theta_r + phi;
d_theta_o = d_theta_r + d_phi;
dd_theta_o = dd_theta_r + dd_phi;

% position of contact point
W_p_c = R_theta(theta_o)*[r_r; 0] + [x_r; y_r];

% velocity of contact point
d_W_p_c = d_R_theta(theta_o, d_theta_o)*d_theta_o*[r_r; 0] + [d_x_r; d_y_r];

% accleration of contact point
% dd_W_p_c = dd_R_theta(theta_o, d_theta_o, dd_theta_o)*d_theta_o*d_theta_o*[r_r; 0] ...
%            + d_R_theta(theta_o, d_theta_o)*dd_theta_o*[r_r; 0] + [dd_x_r; dd_y_r];

% position of the object 
W_p_o = [x_r; y_r] + R_theta(theta_o)*[W_o/2+r_r; -d];

% velocity of the object
d_W_p_o=[d_x_r;d_x_r];
d_W_p_o(1) = d_x_r + d_d *sin(phi + theta_r) +d*cos(phi+theta_r)*(d_phi+d_theta_r) -sin(phi+theta_r)*(d_phi+d_theta_r)*(W_o/2 + r_r);
d_W_p_o(2) = d_y_r - d_d*cos(phi + theta_r) + d*sin(phi+theta_r)*(d_phi+d_theta_r) + cos(phi + theta_r)*(d_phi+d_theta_r)*(W_o/2 + r_r) ;
% d_W_p_o = [d_x_r + d_d *sin(phi + theta_r) +d*cos(phi+theta_r)*(d_phi+d_theta_r) -sin(phi+theta_r)*(d_phi+d_theta_r)*(W_o/2 + r_r);
%            d_y_r - d_d*cos(phi + theta_r) + d*sin(phi+theta_r)*(d_phi+d_theta_r) + cos(phi + theta_r)*(d_phi+d_theta_r)*(W_o/2 + r_r) ];
% d_W_p_o = [d_x_r; d_y_r] + d_R_theta(theta_o, d_theta_o)*[W_o/2+r_r; -d] + R_theta(theta_o)*[0; -d_d];

% acceleration of the object 
dd_W_p_o = [dd_x_r;dd_x_r];
dd_W_p_o(1) = dd_x_r + dd_d *sin(phi + theta_r) + d_d *cos(phi + theta_r) * (d_phi + d_theta_r)+d_d*cos(phi+theta_r)*(d_phi+d_theta_r) -d*sin(phi+theta_r)*(d_phi+d_theta_r)*(d_phi+d_theta_r) + d*cos(phi+theta_r)*(dd_phi+dd_theta_r)-cos(phi+theta_r)*(d_phi+d_theta_r)*(d_phi+d_theta_r)*(W_o/2 + r_r) -sin(phi+theta_r)*(dd_phi+dd_theta_r)*(W_o/2 + r_r);
dd_W_p_o(2) = dd_y_r - dd_d*cos(phi + theta_r) + d_d*sin(phi + theta_r)*(d_phi + d_theta_r) +d_d*sin(phi+theta_r)*(d_phi+d_theta_r)+ d*cos(phi+theta_r)*(d_phi+d_theta_r)*(d_phi+d_theta_r) + d*sin(phi+theta_r)*(dd_phi+dd_theta_r) -sin(phi + theta_r)*(d_phi+d_theta_r)*(d_phi+d_theta_r)*(W_o/2 + r_r) + cos(phi + theta_r)*(dd_phi+dd_theta_r)*(W_o/2 + r_r);
% dd_W_p_o = [dd_x_r + dd_d *sin(phi + theta_r) + d_d *cos(phi + theta_r) * (d_phi + d_theta_r)+d_d*cos(phi+theta_r)*(d_phi+d_theta_r) -d*sin(phi+theta_r)*(d_phi+d_theta_r)*(d_phi+d_theta_r) + d*cos(phi+theta_r)*(dd_phi+dd_theta_r)-cos(phi+theta_r)*(d_phi+d_theta_r)^2*(W_o/2 + r_r) -sin(phi+theta_r)*(dd_phi+dd_theta_r)*(W_o/2 + r_r);
%             dd_y_r - dd_d*cos(phi + theta_r) + d_d*sin(phi + theta_r)*(d_phi + d_theta_r) +d_d*sin(phi+theta_r)*(d_phi+d_theta_r)+ d*cos(phi+theta_r)*(d_phi+d_theta_r)^2 + d*sin(phi+theta_r)*(dd_phi+dd_theta_r) -sin(phi + theta_r)*(d_phi+d_theta_r)^2*(W_o/2 + r_r) + cos(phi + theta_r)*(dd_phi+dd_theta_r)*(W_o/2 + r_r)];
% tttdd_W_p_o = [dd_x_r; dd_y_r] + dd_R_theta(theta_o, d_theta_o, dd_theta_o)*[W_o/2+r_r; -d]...
%             + d_R_theta(theta_o, d_theta_o)*[0; -d_d] ...
%             + d_R_theta(theta_o, d_theta_o)*[0; -d_d] + R_theta(theta_o)*[0; -dd_d];

%% get T2
x = [
    x_r;
    y_r;
    theta_r;
    W_p_o(1);
    W_p_o(2);
    theta_o
];

d_x = [
    d_x_r;
    d_y_r;
    d_theta_r;
    d_W_p_o(1);
    d_W_p_o(2);
    d_theta_o
];

dd_x = [
    dd_x_r;
    dd_y_r;
    dd_theta_r;
    dd_W_p_o(1);
    dd_W_p_o(2);
    dd_theta_o
];

syms Tij real

T_4_3 = diff(d_W_p_o(1), d_theta_r);   
T_4_4 = diff(d_W_p_o(1), d_phi);        
T_4_5 = diff(d_W_p_o(1), d_d); 

T_5_3 = diff(d_W_p_o(2), d_theta_r);
T_5_4 = diff(d_W_p_o(2), d_phi);
T_5_5 = diff(d_W_p_o(2), d_d);

Tij = [1     0     0      0     0 
     0     1     0      0     0  
     0     0     1      0     0  
     1     0   T_4_3 T_4_4 T_4_5
     0     1   T_5_3 T_5_4 T_5_5
     0     0     1      1     0];

% test 
% syms T_4_3 T_4_4 T_4_5 T_5_3 T_5_4 T_5_5 real 
syms m_r m_o I_r I_o real
M = diag([m_r m_r I_r m_o m_o I_o]);
% det(T'*M*T) >0

%% get g
g_4 = 2*d_d*cos(phi+theta_r)*(d_phi+d_theta_r) -d*sin(phi+theta_r)*(d_phi+d_theta_r)*(d_phi+d_theta_r) - cos(phi+theta_r)*(d_phi+d_theta_r)*(d_phi+d_theta_r)*(W_o/2+r_r);
g_5 = 2*d_d*sin(phi+theta_r)*(d_phi+d_theta_r) +d*cos(phi+theta_r)*(d_phi+d_theta_r)*(d_phi+d_theta_r) - sin(phi+theta_r)*(d_phi+d_theta_r)*(d_phi+d_theta_r)*(W_o/2+r_r);
g = [0;
    0;
    0;
    g_4;
    g_5;
    0];
% x = [x_r; y_r; theta_r; W_p_o(1); W_p_o(2); theta_o];
% d_x = [d_x_r; d_y_r; d_theta_r; d_W_p_o(1); d_W_p_o(2); d_theta_o];
% dd_x = [dd_x_r; dd_y_r; dd_theta_r; dd_W_p_o(1); dd_W_p_o(2); dd_theta_o];
% q = [x_r; y_r; theta_r; phi; d];
% d_q = [d_x_r; d_y_r; d_theta_r; d_phi; d_d];
% dd_q = [dd_x_r; dd_y_r; dd_theta_r; dd_phi; dd_d];
% g = dd_x - Tij*dd_q;

%% get Q
% we have the friction force between the robot and the object 
% and the normal force between the robot and the object as the
% external force in domain q
%%%%
% note: we didn't consider the friction force between the robot
% and the ground. Because there is a pid controller on the robot to do
% differentical control -- make the robot state the work the same as the
% command
% so we can assume W_F_p = m_o*[dd_x_r; dd_y_r]
%%%%
syms mu_p
% The force exerted by the robot to the object
F_ro = R_theta(-phi) * m_r * [dd_x_r; dd_y_r];
% 1. the push force between the robot and the object
F_p_ro = F_ro(1);
% 2. the friction force between the robot and the object 
F_f_ro = mu_p * F_p_ro * sigmoid_adap(d_d);

% Q = [0; 0; 0; 0; F_f_ro];
Q = [0; 0; 0; 0; 0];
%% get F
% we have the push force and the friction force between the ground and the object as the
% external force in domain x
% calculate the friction force and moment
obj_size_W = 0.5;
obj_size_L = 0.8;
syms mu_g grav_acc
obj_size = [obj_size_W,obj_size_L];
% ellipsoid approximation
% f_x^2/f_t_max^2 + f_y^2/f_t_max^2 + m_z^2/m_z_max^2 = 1
% lambda = m_z_max/f_t_max, which is related to the object contact shape
fun = @(x,y) sqrt(x.^2+y.^2);
lambda = (obj_size_W*obj_size_L)/dblquad(fun,-obj_size_W/2,obj_size_W/2,-obj_size_L,obj_size_L); 
F_fg = -mu_g * m_o * grav_acc * [d_W_p_o(1);d_W_p_o(2);lambda*d_theta_o]/sqrt(d_W_p_o(1)^2 + d_W_p_o(2)^2 + (lambda*d_theta_o)^2);

% the friction force between the ground and the object expressed in the
% object frame
O_F_fg = R_theta(-theta_o) * F_fg(1:2);

F = [0; 0; 0; O_F_fg(1); O_F_fg(2); F_fg(3)];

%% 
dd_q = inv(Tij.'*M*Tij)*( Q + Tij.'*(F-M*g) );
dd_q = inv(Tij.'*M*Tij)*(  + Tij.'*(-M*g) );

MMM = inv(Tij.'*M*Tij)
MMM(1,1) = (I_o*m_r + I_o*m_o*sin(phi + theta_r)^2 + d^2*m_o*m_r)/(I_o*m_r^2 + d^2*m_o*m_r^2 + I_o*m_o*m_r);
MMM(1,2) = -(I_o*m_o*cos(phi + theta_r)*sin(phi + theta_r))/(I_o*m_r^2 + d^2*m_o*m_r^2 + I_o*m_o*m_r);
MMM(1,3) = 0;
MMM(1,4) = -(d*m_o*cos(phi + theta_r))/(m_o*m_r*d^2 + I_o*m_o + I_o*m_r);
MMM(1,5) = -(2*I_o*m_o*sin(phi + theta_r) + 2*I_o*m_r*sin(phi + theta_r) +  2*d*m_o*m_r*r_r*cos(phi + theta_r) + 2*d^2*m_o*m_r*sin(phi + theta_r) + W_o*d*m_o*m_r*cos(phi + theta_r))/(2*(I_o*m_r^2 + d^2*m_o*m_r^2 + I_o*m_o*m_r));

MMM(2,1) = -(I_o*m_o*cos(phi + theta_r)*sin(phi + theta_r))/(I_o*m_r^2 + d^2*m_o*m_r^2 + I_o*m_o*m_r);
MMM(2,2) = (I_o*m_o*cos(phi + theta_r)^2 + I_o*m_r + d^2*m_o*m_r)/(I_o*m_r^2 + d^2*m_o*m_r^2 + I_o*m_o*m_r);
MMM(2,3) = 0;
MMM(2,4) = -(d*m_o*sin(phi + theta_r))/(m_o*m_r*d^2 + I_o*m_o + I_o*m_r);
MMM(2,5) = (2*I_o*m_o*cos(phi + theta_r) + 2*I_o*m_r*cos(phi + theta_r) - W_o*d*m_o*m_r*sin(phi + theta_r) - 2*d*m_o*m_r*r_r*sin(phi + theta_r) + 2*d^2*m_o*m_r*cos(phi + theta_r))/(2*(I_o*m_r^2 + d^2*m_o*m_r^2 + I_o*m_o*m_r));

MMM(3,1) = 0;
MMM(3,2) = 0;
MMM(3,3) = 1/I_r;
MMM(3,4) = -1/I_r;
MMM(3,5) = 0;

MMM(4,1) = -(d*m_o*cos(phi + theta_r))/(m_o*m_r*d^2 + I_o*m_o + I_o*m_r);
MMM(4,2) = -(d*m_o*sin(phi + theta_r))/(m_o*m_r*d^2 + I_o*m_o + I_o*m_r);
MMM(4,3) = -1/I_r;
MMM(4,4) = (m_o*m_r*d^2 + I_o*m_o + I_o*m_r + I_r*m_o + I_r*m_r)/(I_r*(m_o*m_r*d^2 + I_o*m_o + I_o*m_r));
MMM(4,5) = (W_o*m_o + W_o*m_r + 2*m_o*r_r + 2*m_r*r_r)/(2*(m_o*m_r*d^2 + I_o*m_o + I_o*m_r));

MMM(5,1) = -(2*I_o*m_o*sin(phi + theta_r) + 2*I_o*m_r*sin(phi + theta_r) + 2*d^2*m_o*m_r*sin(phi + theta_r) + W_o*d*m_o*m_r*cos(phi + theta_r) + 2*d*m_o*m_r*r_r*cos(phi + theta_r))/(2*(I_o*m_r^2 + d^2*m_o*m_r^2 + I_o*m_o*m_r));
MMM(5,2) = (2*I_o*m_o*cos(phi + theta_r) + 2*I_o*m_r*cos(phi + theta_r) + 2*d^2*m_o*m_r*cos(phi + theta_r) - W_o*d*m_o*m_r*sin(phi + theta_r) - 2*d*m_o*m_r*r_r*sin(phi + theta_r))/(2*(I_o*m_r^2 + d^2*m_o*m_r^2 + I_o*m_o*m_r));
MMM(5,3) = 0;
MMM(5,4) = (W_o*m_o + W_o*m_r + 2*m_o*r_r + 2*m_r*r_r)/(2*(m_o*m_r*d^2 + I_o*m_o + I_o*m_r));
MMM(5,5) =(4*I_o*m_o^2 + 4*I_o*m_r^2 + 8*I_o*m_o*m_r + W_o^2*m_o^2*m_r + 4*d^2*m_o*m_r^2 + 4*d^2*m_o^2*m_r + W_o^2*m_o*m_r^2 + 4*m_o*m_r^2*r_r^2 + 4*m_o^2*m_r*r_r^2 + 4*W_o*m_o*m_r^2*r_r + 4*W_o*m_o^2*m_r*r_r)/(4*m_o*(I_o*m_r^2 + d^2*m_o*m_r^2 + I_o*m_o*m_r + 2*d^2*m_o*m_r^2*cos(phi + theta_r)^2*sin(phi + theta_r)^2));


