syms x_r y_r theta_r phi d  real
syms d_x_r d_y_r d_theta_r d_phi d_d real
syms dd_x_r dd_y_r dd_theta_r dd_phi dd_d real
syms v_r acc_r real
syms x_o y_o theta_o real
% syms r_r W_o real
% syms m_r m_o I_r I_o real

r_r = 0.15;
W_o = 0.5;
L_o = 0.5;
m_o = 3.0;
m_r = 3.0;
I_o = 0.125;
I_r = 0.125;
mu_g = 0.3;
mu_p = 0.2;
grav_acc = 9.8;

% initialization   
% state = [x_r, y_r, theta_r, v_r, d_theta_r, phi, d, d_phi, d_d]
% state = [0., 0., 0., 0.1, 0.0,...
%         0.,  1. , 0. , 0.0];
state = [-0.85281175, -1.14667393,  1.25217711,  0.15719705, -0.12726424,...
        0.11117236,  0.1127972 ,  0.58933858,  0.31527793];
acc_r = 0.;


x_r = state(1);
y_r = state(2);
theta_r = state(3);
v_r = state(4);
d_theta_r = state(5);
phi = state(6);
d = state(7);
d_phi = state(8);
d_d = state(9);

d_x_r = cos(theta_r) * v_r;
d_y_r = sin(theta_r) * v_r;

dd_x_r = -sin(theta_r) * d_theta_r * v_r + cos(theta_r) * acc_r;
dd_y_r = cos(theta_r) * d_theta_r * v_r + sin(theta_r) * acc_r;

theta_o = theta_r + phi;
d_theta_o = d_theta_r + d_phi;
dd_theta_o = dd_theta_r + dd_phi;

% position of the object 
W_p_o = [x_r; y_r] + R_theta(theta_o)*[W_o/2+r_r; -d];

% velocity of the object 
d_W_p_o_1 = d_x_r + d_d *sin(phi + theta_r) +d*cos(phi+theta_r)*(d_phi+d_theta_r) -sin(phi+theta_r)*(d_phi+d_theta_r)*(W_o/2 + r_r);
d_W_p_o_2 = d_y_r - d_d*cos(phi + theta_r) + d*sin(phi+theta_r)*(d_phi+d_theta_r) + cos(phi + theta_r)*(d_phi+d_theta_r)*(W_o/2 + r_r) ;
d_W_p_o = [d_W_p_o_1; d_W_p_o_2];

% acceleration of the object 
dd_W_p_o_1 = dd_x_r + dd_d *sin(phi + theta_r) + d_d *cos(phi + theta_r) * (d_phi + d_theta_r)+d_d*cos(phi+theta_r)*(d_phi+d_theta_r) -d*sin(phi+theta_r)*(d_phi+d_theta_r)*(d_phi+d_theta_r) + d*cos(phi+theta_r)*(dd_phi+dd_theta_r)-cos(phi+theta_r)*(d_phi+d_theta_r)*(d_phi+d_theta_r)*(W_o/2 + r_r) -sin(phi+theta_r)*(dd_phi+dd_theta_r)*(W_o/2 + r_r);
dd_W_p_o_2 = dd_y_r - dd_d*cos(phi + theta_r) + d_d*sin(phi + theta_r)*(d_phi + d_theta_r) +d_d*sin(phi+theta_r)*(d_phi+d_theta_r)+ d*cos(phi+theta_r)*(d_phi+d_theta_r)*(d_phi+d_theta_r) + d*sin(phi+theta_r)*(dd_phi+dd_theta_r) -sin(phi + theta_r)*(d_phi+d_theta_r)*(d_phi+d_theta_r)*(W_o/2 + r_r) + cos(phi + theta_r)*(dd_phi+dd_theta_r)*(W_o/2 + r_r);
dd_W_p_o = [dd_W_p_o_1; dd_W_p_o_2];

%% get T2
x = [
    x_r;
    y_r;
    theta_r;
    W_p_o(1);
    W_p_o(2);
    theta_o
];

d_x = [
    d_x_r;
    d_y_r;
    d_theta_r;
    d_W_p_o(1);
    d_W_p_o(2);
    d_theta_o
];

syms Tij real

T_4_3 = d*cos(phi + theta_r) - sin(phi + theta_r)*(W_o/2 + r_r); % diff(d_W_p_o(1), d_theta_r)
T_4_4 = d*cos(phi + theta_r) - sin(phi + theta_r)*(W_o/2 + r_r); % diff(d_W_p_o(1), d_phi)        
T_4_5 = sin(phi + theta_r);    % diff(d_W_p_o(1), d_d) 

T_5_3 = d*sin(phi + theta_r) + cos(phi + theta_r)*(W_o/2 + r_r); % diff(d_W_p_o(2), d_theta_r)
T_5_4 = d*sin(phi + theta_r) + cos(phi + theta_r)*(W_o/2 + r_r); % diff(d_W_p_o(2), d_phi)
T_5_5 = -cos(phi + theta_r); % diff(d_W_p_o(2), d_d)

Tij = [1     0     0      0     0 
     0     1     0      0     0  
     0     0     1      0     0  
     1     0   T_4_3 T_4_4 T_4_5
     0     1   T_5_3 T_5_4 T_5_5
     0     0     1      1     0];

% test 
% syms T_4_3 T_4_4 T_4_5 T_5_3 T_5_4 T_5_5 real 
M = diag([m_r m_r I_r m_o m_o I_o]);
% det(T.'*M*T) >0

%% get g
g_4 = 2*d_d*cos(phi+theta_r)*(d_phi+d_theta_r) -d*sin(phi+theta_r)*(d_phi+d_theta_r)*(d_phi+d_theta_r) - cos(phi+theta_r)*(d_phi+d_theta_r)*(d_phi+d_theta_r)*(W_o/2+r_r);
g_5 = 2*d_d*sin(phi+theta_r)*(d_phi+d_theta_r) +d*cos(phi+theta_r)*(d_phi+d_theta_r)*(d_phi+d_theta_r) - sin(phi+theta_r)*(d_phi+d_theta_r)*(d_phi+d_theta_r)*(W_o/2+r_r);
g = [0;
    0;
    0;
    g_4;
    g_5;
    0];
% x = [x_r; y_r; theta_r; W_p_o(1); W_p_o(2); theta_o];
% d_x = [d_x_r; d_y_r; d_theta_r; d_W_p_o(1); d_W_p_o(2); d_theta_o];
% dd_x = [dd_x_r; dd_y_r; dd_theta_r; dd_W_p_o(1); dd_W_p_o(2); dd_theta_o];
% q = [x_r; y_r; theta_r; phi; d];
% d_q = [d_x_r; d_y_r; d_theta_r; d_phi; d_d];
% dd_q = [dd_x_r; dd_y_r; dd_theta_r; dd_phi; dd_d];
% g = dd_x - Tij*dd_q;

%% get Q
% we have the friction force between the robot and the object 
% and the normal force between the robot and the object as the
% external force in domain q
%%%%
% note: we didn't consider the friction force between the robot
% and the ground. Because there is a pid controller on the robot to do
% differentical control -- make the robot state the work the same as the
% command
% so we can assume W_F_p = m_o*[dd_x_r; dd_y_r]
%%%%
% The force exerted by the robot to the object in the object frame
F_ro = R_theta(-phi) * m_r * [dd_x_r; dd_y_r];
% 1. the push force between the robot and the object
F_p_ro = F_ro(1);
% 2. the friction force between the robot and the object 
F_f_ro = mu_p * F_p_ro * sigmoid_adap(d_d);

Q = [0; 0; 0; 0; F_f_ro];
%  Q = [0; 0; 0; 0; 0];

%% get F
% we have the push force and the friction force between the ground and the object as the
% external force in domain x
% calculate the friction force and moment
obj_size = [W_o,L_o];
inte_f = [0.0, 0.0];
inte_m = 0.0;
pos_corner_o = [[obj_size(1)/2.0, obj_size(2)/2.0]; ...
                        [obj_size(1)/2.0, obj_size(2)/-2.0]; ...
                        [obj_size(1)/-2.0, obj_size(2)/-2.0]; ...
                        [obj_size(1)/-2.0, obj_size(2)/2.0]];   % position of the corners in the object frame
for i=1:4  % for the object with four legs
    O_x = pos_corner_o(i, 1);
    O_y = pos_corner_o(i, 2);
    sig_v_O_x = [sigmoid_adap(-d_theta_o*(O_y*cos(theta_o) + O_x*sin(theta_o) - d_W_p_o(1)/d_theta_o)), ...
                    sigmoid_adap(d_theta_o*(O_x*cos(theta_o) - O_y*sin(theta_o) + d_W_p_o(2)/d_theta_o))];
    inte_f = inte_f + sig_v_O_x;

    O_sig_v_O_x = [sig_v_O_x(1) * cos(theta_o) + sig_v_O_x(2) * sin(theta_o), ...
                - sig_v_O_x(1) * sin(theta_o) + sig_v_O_x(2) * cos(theta_o)];
    inte_m = inte_m + (O_x * O_sig_v_O_x(2) - O_y * O_sig_v_O_x(1));
end
F_fg = -mu_g * m_o * grav_acc / 4 * [inte_f(1); inte_f(2)];
M_fg = -mu_g* m_o * grav_acc / 4 * inte_m ;
% the friction force between the ground and the object expressed in the
% object frame
O_F_fg = R_theta(-theta_o) * F_fg;

F = [0; 0; 0; O_F_fg(1); O_F_fg(2); M_fg];
% F = [0; 0; 0; 0; 0; 0];
%% 
dd_q = inv(Tij.'*M*Tij)*( Q + Tij.'*(F-M*g) );
dd_q = inv(Tij.'*M*Tij)*(  + Tij.'*(-M*g) )